                processor 6502 
                include "vcs.h" 
                include "macro.h" 
                include "jumpmacro.h" 

    SEG.U vars
    ORG $80

customarea1         ds 7    ; Sub-optimal RAM usage!! DEBUG!
customarea2         ds 7
customarea3         ds 7
customarea4         ds 7
customarea5         ds 7
customarea6         ds 7

frameCounter        ds 1

    SEG Bank0
    ORG $F000 

Start
    CLEAN_START
    LDA #$A2
    STA COLUPF
    LDA #1
    STA CTRLPF

    JSR BombsInit

Start_Frame 
    VERTICAL_SYNC

; Vertical Blank

    LDX 37
Vertical_Blank  
    STA WSYNC 
    DEX 
    BNE Vertical_Blank 

; Kernel
    STA VBLANK  ; Enable TIA Output

    ASSYMMETRICALJUMPMANKERNEL JUMP_PF1-DRAGON_TOP, DRAGON_TOP-JUMP_PF0
    CUSTOMPF1PF2JUMPMANKERNEL DRAGON_TOP-DRAGON_CUSTOM1, DRAGON_CUSTOM1-JUMP_PF0, JUMP_PF1+DRAGON_CUSTOM1-JUMP_PF0, customarea2, JUMP_PF2+DRAGON_CUSTOM1-JUMP_PF0, customarea1
    ASSYMMETRICALJUMPMANKERNEL DRAGON_CUSTOM1-DRAGON_MIDDLE1, DRAGON_MIDDLE1-JUMP_PF0
    CUSTOMPF1PF2JUMPMANKERNEL DRAGON_MIDDLE1-DRAGON_CUSTOM2, DRAGON_CUSTOM2-JUMP_PF0, JUMP_PF1+DRAGON_CUSTOM2-JUMP_PF0, JUMP_PF4+DRAGON_CUSTOM2-JUMP_PF0, customarea3, customarea4
    ASSYMMETRICALJUMPMANKERNEL DRAGON_CUSTOM2-DRAGON_MIDDLE2, DRAGON_MIDDLE2-JUMP_PF0
    CUSTOMPF1PF2JUMPMANKERNEL DRAGON_MIDDLE2-DRAGON_CUSTOM3, DRAGON_CUSTOM3-JUMP_PF0, customarea5, JUMP_PF4+DRAGON_CUSTOM3-JUMP_PF0, customarea6, JUMP_PF3+DRAGON_CUSTOM3-JUMP_PF0
    ASSYMMETRICALJUMPMANKERNEL DRAGON_CUSTOM3-JUMP_PF0, 0

    STA WSYNC
    LDA #0
    STA PF0
    STA PF1
    STA PF2
    LDA #2      ; Disable TIA Output
    STA VBLANK           

; Overscan
    
    LDX #30 
Overscan        STA WSYNC 
    DEX 
    BNE Overscan 

; Test code for custom zones!
    JSR BombsInit
    INC frameCounter
    LDA frameCounter
    LSR
    LSR
    LSR
    LSR
    LSR
    LSR
    BCC FirstZoneFine

    LDX #$FF
    STX customarea1
    STX customarea1+1
    STX customarea1+2
    STX customarea2
    STX customarea2+1
    STX customarea2+2
    INX
    STX customarea1+3
    STX customarea1+4
    STX customarea1+5
    STX customarea1+6
    STX customarea2+3
    STX customarea2+4
    STX customarea2+5
    STX customarea2+6
    
FirstZoneFine
    LSR
    BCC SecondZoneFine

    LDX #$FF
    STX customarea3
    STX customarea3+1
    STX customarea3+2
    STX customarea4
    STX customarea4+1
    STX customarea4+2
    INX
    STX customarea3+3
    STX customarea3+4
    STX customarea3+5
    STX customarea3+6
    STX customarea4+3
    STX customarea4+4
    STX customarea4+5
    STX customarea4+6

SecondZoneFine
    LSR
    BCC Done

    LDX #$FF
    STX customarea5
    STX customarea5+1
    STX customarea5+2
    STX customarea6
    STX customarea6+1
    STX customarea6+2
    INX
    STX customarea5+3
    STX customarea5+4
    STX customarea5+5
    STX customarea5+6
    STX customarea6+3
    STX customarea6+4
    STX customarea6+5
    STX customarea6+6

Done    

    JMP Start_Frame     ; Build Next Frame

; Initing sub ->DEBUG<-

BombsInit
; Init Custom kernel zones    
    LDX 6
InitCustomZones
    LDA JUMP_PF3+DRAGON_CUSTOM1-JUMP_PF0,X
    STA customarea1,X
    LDA JUMP_PF4+DRAGON_CUSTOM1-JUMP_PF0,X
    STA customarea2,X
    LDA JUMP_PF2+DRAGON_CUSTOM2-JUMP_PF0,X
    STA customarea3,X
    LDA JUMP_PF3+DRAGON_CUSTOM2-JUMP_PF0,X
    STA customarea4,X
    LDA JUMP_PF1+DRAGON_CUSTOM3-JUMP_PF0,X
    STA customarea5,X
    LDA JUMP_PF2+DRAGON_CUSTOM3-JUMP_PF0,X
    STA customarea6,X
    DEX
    BPL InitCustomZones
    RTS

; Data

    ORG $F800

JUMP_PF0
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
DRAGON_CUSTOM3
                                .byte   %11000000
                                .byte   %11000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
DRAGON_MIDDLE2
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
DRAGON_CUSTOM2
                                .byte   %11000000
                                .byte   %11000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
DRAGON_MIDDLE1
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
DRAGON_CUSTOM1
                                .byte   %11000000
                                .byte   %11000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
DRAGON_TOP
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000

JUMP_PF1
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %11100000
                                .byte   %11110001
                                .byte   %00111011
                                .byte   %00011111
                                .byte   %00001110
                                .byte   %00000100
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000

    ORG $F900

JUMP_PF2
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %11111110
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000001
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00001111
                                .byte   %00011111
                                .byte   %00111111
                                .byte   %01110000
                                .byte   %11100000
                                .byte   %11000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000

JUMP_PF3
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00001111
                                .byte   %00011111
                                .byte   %00111111
                                .byte   %01110000
                                .byte   %11100000
                                .byte   %11000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %11111110
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000001
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000

    ORG $FA00

JUMP_PF4
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %11100000
                                .byte   %11110001
                                .byte   %00111011
                                .byte   %00011111
                                .byte   %00001110
                                .byte   %00000100
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000

JUMP_PF5
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %11000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %11000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %11000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000

    ORG $FFFA
    .WORD Start
    .WORD Start
    .WORD Start