                processor 6502 
                include "vcs.h" 
                include "macro.h" 
                include "jumpmacro.h" 

    SEG.U vars
    ORG $80

customarea1         ds 3

frameCounter        ds 1

    SEG Bank0
    ORG $F000 

Start
    CLEAN_START
    LDA #$A2
    STA COLUPF
    LDA #1
    STA CTRLPF

    JSR EasyInit

Start_Frame 
    VERTICAL_SYNC

; Vertical Blank

    LDX 37
Vertical_Blank  
    STA WSYNC 
    DEX 
    BNE Vertical_Blank 

; Kernel
    STA VBLANK  ; Enable TIA Output

    SYMMETRICALJUMPMANKERNEL JUMP_PF1-GPII_TOP, GPII_TOP-JUMP_PF0
    CUSTOMSYMMETRICALPF2KERNEL GPII_TOP-GPII_CUSTOM1, GPII_CUSTOM1-JUMP_PF0, customarea1
    SYMMETRICALJUMPMANKERNEL GPII_CUSTOM1-JUMP_PF0, 0

    STA WSYNC
    LDA #0
    STA PF0
    STA PF1
    STA PF2
    LDA #2      ; Disable TIA Output
    STA VBLANK           

; Overscan
    
    LDX #16 
Overscan        STA WSYNC 
    DEX 
    BNE Overscan 

; Test code for custom zones!
    JSR EasyInit
    INC frameCounter
    LDA frameCounter
    LSR
    LSR
    LSR
    LSR
    LSR
    LSR
    LSR
    LSR
    BCC Done

    LDX #2
Zone1
    LDA customarea1,X
    AND #%01111111
    STA customarea1,X
    DEX
    BPL Zone1
Done    

    JMP Start_Frame     ; Build Next Frame

; Initing sub ->DEBUG<-

EasyInit
; Init Custom kernel zones    
    LDX #2
InitCustomZones
    LDA JUMP_PF2+GPII_CUSTOM1-JUMP_PF0,X
    STA customarea1,X
    DEX
    BPL InitCustomZones
    RTS

; Data

    ORG $F800

JUMP_PF0
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
GPII_CUSTOM1
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
GPII_TOP
                                .byte   %00000000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000

JUMP_PF1
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11111100
                                .byte   %11111100
                                .byte   %11111100
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11111100
                                .byte   %11111100
                                .byte   %11111100
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000

    ORG $F900

JUMP_PF2
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %00000000
                                .byte   %11111110
                                .byte   %11111110
                                .byte   %11111110
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %00000000
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %00000000
                                .byte   %11111110
                                .byte   %11111110
                                .byte   %11111110
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %00000000
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000

    ORG $FFFA
    .WORD Start
    .WORD Start
    .WORD Start