                processor 6502 
                include "vcs.h" 
                include "macro.h" 
                include "jumpmacro.h" 

    SEG.U vars
    ORG $80

customarea1         ds 3
customarea2         ds 3
customarea3         ds 8
customarea4         ds 8
customarea5         ds 8
customarea6         ds 8

frameCounter        ds 1

    SEG Bank0
    ORG $F000 

Start
    CLEAN_START
    LDA #$A2
    STA COLUPF
    LDA #1
    STA CTRLPF

    JSR EasyInit

Start_Frame 
    VERTICAL_SYNC

; Vertical Blank

    LDX 37
Vertical_Blank  
    STA WSYNC 
    DEX 
    BNE Vertical_Blank 

; Kernel
    STA VBLANK  ; Enable TIA Output

    SYMMETRICALJUMPMANKERNEL JUMP_PF1-RIDE_TOP, RIDE_TOP-JUMP_PF0
    CUSTOMPF2JUMPMANKERNEL RIDE_TOP-RIDE_CUSTOM1, RIDE_CUSTOM1-JUMP_PF0, customarea1, customarea2
    SYMMETRICALJUMPMANKERNEL RIDE_CUSTOM1-RIDE_MIDDLE, RIDE_MIDDLE-JUMP_PF0
    CUSTOMPF1PF2JUMPMANKERNEL RIDE_MIDDLE-RIDE_CUSTOM2, RIDE_CUSTOM2-JUMP_PF0, customarea3, customarea4, customarea5, customarea6
    SYMMETRICALJUMPMANKERNEL RIDE_CUSTOM2-JUMP_PF0, 0

    STA WSYNC
    LDA #0
    STA PF0
    STA PF1
    STA PF2
    LDA #2      ; Disable TIA Output
    STA VBLANK           

; Overscan
    
    LDX #30 
Overscan        STA WSYNC 
    DEX 
    BNE Overscan 

; Test code for custom zones!
    JSR EasyInit
    INC frameCounter
    LDA frameCounter
    LSR
    LSR
    LSR
    LSR
    LSR
    BCC FirstZoneFine

    TAY
    LDX #2
Zone1
    LDA customarea1,X
    AND #%00011111
    STA customarea1,X
    DEX
    BPL Zone1
    TYA

FirstZoneFine
    LSR
    BCC SecondZoneFine
    
    TAY
    LDX #2
Zone2
    LDA customarea2,X
    AND #%00011111
    STA customarea2,X
    DEX
    BPL Zone2
    TYA

SecondZoneFine
    LSR
    BCC ThirdZoneFine

    TAY
    LDX 7
Zone3
    LDA customarea3,X
    AND #%11111110
    STA customarea3,X
    LDA customarea5,X
    AND #%11100000
    STA customarea5,X
    DEX
    BPL Zone3
    TYA

ThirdZoneFine
    LSR
    BCC Done

    LDX 7
Zone4
    LDA customarea4,X
    AND #%11111110
    STA customarea4,X
    LDA customarea6,X
    AND #%11100000
    STA customarea6,X
    DEX
    BPL Zone4
    
Done    

    JMP Start_Frame     ; Build Next Frame

; Initing sub ->DEBUG<-

EasyInit
; Init Custom kernel zones    
    LDX 7
InitCustomZones
    LDA JUMP_PF2+RIDE_CUSTOM1-JUMP_PF0,X
    STA customarea1,X
    STA customarea2,X
    LDA JUMP_PF1+RIDE_CUSTOM2-JUMP_PF0,X
    STA customarea3,X
    STA customarea4,X
    LDA JUMP_PF2+RIDE_CUSTOM2-JUMP_PF0,X
    STA customarea5,X
    STA customarea6,X
    DEX
    BPL InitCustomZones
    RTS

; Data

    ORG $F800

JUMP_PF0
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
RIDE_CUSTOM2
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
RIDE_MIDDLE
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
RIDE_CUSTOM1
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
RIDE_TOP
                                .byte   %00000000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000


JUMP_PF1
                                .byte   %11111110
                                .byte   %11111110
                                .byte   %11111110
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %10011000
                                .byte   %00000000
                                .byte   %10011000
                                .byte   %00000000
                                .byte   %10011000
                                .byte   %00000000
                                .byte   %10011000
                                .byte   %00000000
                                .byte   %10011000
                                .byte   %00000000
                                .byte   %10011000
                                .byte   %10000000
                                .byte   %10011000
                                .byte   %00000000
                                .byte   %10011000
                                .byte   %00000001
                                .byte   %10011111
                                .byte   %00011111
                                .byte   %10011110
                                .byte   %00000000
                                .byte   %10011000
                                .byte   %00000000
                                .byte   %10011000
                                .byte   %00000000
                                .byte   %10011000
                                .byte   %00000000
                                .byte   %10011000
                                .byte   %00000000
                                .byte   %10011000
                                .byte   %00000000
                                .byte   %10011000
                                .byte   %00000000
                                .byte   %11111100
                                .byte   %11111100
                                .byte   %11111100
                                .byte   %00000000
                                .byte   %10011000
                                .byte   %00000000
                                .byte   %10011000
                                .byte   %00000000
                                .byte   %00011000
                                .byte   %00000000
                                .byte   %00011000
                                .byte   %00000000
                                .byte   %00011000
                                .byte   %00000000
                                .byte   %00011000
                                .byte   %00000000
                                .byte   %00111111
                                .byte   %00111111
                                .byte   %00111111
                                .byte   %00000000
                                .byte   %00011001
                                .byte   %00000000
                                .byte   %00011001
                                .byte   %00000000
                                .byte   %00000001
                                .byte   %00000000
                                .byte   %00000001
                                .byte   %00000000
                                .byte   %00000001
                                .byte   %00000000
                                .byte   %00000001
                                .byte   %00000000
                                .byte   %00000001
                                .byte   %00000000
                                .byte   %00000001
                                .byte   %00000000
                                .byte   %10000111
                                .byte   %10000111
                                .byte   %10000111
                                .byte   %00000000
                                .byte   %00000001
                                .byte   %00000000
                                .byte   %00000001
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000

    ORG $F900

JUMP_PF2
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %10000000
                                .byte   %00000000
                                .byte   %11110000
                                .byte   %11111000
                                .byte   %11111100
                                .byte   %00001110
                                .byte   %10000111
                                .byte   %00000011
                                .byte   %10000001
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %11000000
                                .byte   %11000000
                                .byte   %11000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000001
                                .byte   %00000001
                                .byte   %00000001
                                .byte   %00000000
                                .byte   %00000001
                                .byte   %00000000
                                .byte   %00000001
                                .byte   %00000000
                                .byte   %00000001
                                .byte   %00000000
                                .byte   %00000001
                                .byte   %00000000
                                .byte   %00000001
                                .byte   %00000000
                                .byte   %00000001
                                .byte   %00000000
                                .byte   %11100001
                                .byte   %11110000
                                .byte   %11111001
                                .byte   %00011100
                                .byte   %00001111
                                .byte   %00000111
                                .byte   %00000011
                                .byte   %00000000
                                .byte   %00000001
                                .byte   %00000000
                                .byte   %00000001
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000

    ORG $FFFA
    .WORD Start
    .WORD Start
    .WORD Start