    processor 6502
    include "vcs.h" 
    include "macro.h" 
    include "jumpmacro.h" 

    SEG.U vars
    ORG $80

frameCounter        ds 1

    SEG Bank0
    ORG $F000 

Start
    CLEAN_START
    LDA #$A2
    STA COLUPF
    LDA #1
    STA CTRLPF

Start_Frame 
    VERTICAL_SYNC

; Vertical Blank

    LDX 37
Vertical_Blank  
    STA WSYNC 
    DEX 
    BNE Vertical_Blank 

; Kernel
    STA VBLANK  ; Enable TIA Output

    ASSYMMETRICALJUMPMANKERNEL JUMP_PF1-JUMP_PF0, 0

    STA WSYNC
    LDA #0
    STA PF0
    STA PF1
    STA PF2
    LDA #2      ; Disable TIA Output
    STA VBLANK           

; Overscan
    
    LDX #30 
Overscan        STA WSYNC 
    DEX 
    BNE Overscan 

    JMP Start_Frame     ; Build Next Frame

    ORG $F800

; Data

JUMP_PF0
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000

JUMP_PF1
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %01100110
                                .byte   %00000000
                                .byte   %01100110
                                .byte   %00000000
                                .byte   %00000110
                                .byte   %00000000
                                .byte   %00000110
                                .byte   %00000000
                                .byte   %00000110
                                .byte   %00000000
                                .byte   %00000110
                                .byte   %00000000
                                .byte   %11111110
                                .byte   %11111110
                                .byte   %11111110
                                .byte   %00000000
                                .byte   %00000110
                                .byte   %00000000
                                .byte   %00000110
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %01100110
                                .byte   %00000000
                                .byte   %01100110
                                .byte   %00000000
                                .byte   %00000110
                                .byte   %00000000
                                .byte   %00000110
                                .byte   %00000000
                                .byte   %00000110
                                .byte   %00000000
                                .byte   %00000110
                                .byte   %00000000
                                .byte   %00001111
                                .byte   %00001111
                                .byte   %00001111
                                .byte   %00000000
                                .byte   %00000110
                                .byte   %00000000
                                .byte   %00000110
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000

    ORG $F900

JUMP_PF2
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %00011000
                                .byte   %00000000
                                .byte   %00011000
                                .byte   %00000000
                                .byte   %00011000
                                .byte   %00000000
                                .byte   %00011000
                                .byte   %00000000
                                .byte   %00011000
                                .byte   %00000000
                                .byte   %00011000
                                .byte   %00000000
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %00011000
                                .byte   %00000000
                                .byte   %00011000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %11111000
                                .byte   %11111000
                                .byte   %11111000
                                .byte   %00000000
                                .byte   %00011000
                                .byte   %00000000
                                .byte   %00011000
                                .byte   %00000000
                                .byte   %00011000
                                .byte   %00000000
                                .byte   %00011000
                                .byte   %00000000
                                .byte   %00011000
                                .byte   %00000000
                                .byte   %00011000
                                .byte   %00000000
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %00011000
                                .byte   %00000000
                                .byte   %00011000
                                .byte   %00000000
                                .byte   %00011000
                                .byte   %00000000
                                .byte   %00011000
                                .byte   %00000000
                                .byte   %00011000
                                .byte   %00000000
                                .byte   %00011000
                                .byte   %00000000
                                .byte   %00011111
                                .byte   %00011111
                                .byte   %00011111
                                .byte   %00000000
                                .byte   %00011000
                                .byte   %00000000
                                .byte   %00011000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000

JUMP_PF3
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %11110000
                                .byte   %11110000
                                .byte   %11110000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %11111000
                                .byte   %11111000
                                .byte   %11111000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01111111
                                .byte   %01111111
                                .byte   %01111111
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %11110000
                                .byte   %11110000
                                .byte   %11110000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000

    ORG $FA00

JUMP_PF4
                                .byte   %10001111
                                .byte   %10001111
                                .byte   %10001111
                                .byte   %00000000
                                .byte   %00000110
                                .byte   %00000000
                                .byte   %00000110
                                .byte   %00000000
                                .byte   %00000110
                                .byte   %00000000
                                .byte   %00000110
                                .byte   %00000000
                                .byte   %00000110
                                .byte   %00000000
                                .byte   %00000110
                                .byte   %00000000
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %00000110
                                .byte   %00000000
                                .byte   %00000110
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %00000110
                                .byte   %00000000
                                .byte   %00000110
                                .byte   %00000000
                                .byte   %00000110
                                .byte   %00000000
                                .byte   %00000110
                                .byte   %00000000
                                .byte   %00000110
                                .byte   %00000000
                                .byte   %00000110
                                .byte   %00000000
                                .byte   %11111110
                                .byte   %11111110
                                .byte   %11111110
                                .byte   %00000000
                                .byte   %00000110
                                .byte   %00000000
                                .byte   %00000110
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %00000110
                                .byte   %00000000
                                .byte   %00000110
                                .byte   %00000000
                                .byte   %00000110
                                .byte   %00000000
                                .byte   %00000110
                                .byte   %00000000
                                .byte   %00000110
                                .byte   %00000000
                                .byte   %00000110
                                .byte   %00000000
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %11111111
                                .byte   %00000000
                                .byte   %00000110
                                .byte   %00000000
                                .byte   %00000110
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000

JUMP_PF5
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %01100000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %11100000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000
                                .byte   %00000000

    ORG $FFFA
    .WORD Start
    .WORD Start
    .WORD Start